#include <stdio.h>
#include <stdbool.h>

#define LIN 9
#define COL 9

bool verifica_linha(int, int [][COL]);
bool verifica_coluna(int, int [][COL]);
bool verifica_regiao(int, int [][COL]);
bool tem_nulo(bool []);

int main()
{
    int tab[LIN][COL], i, j, k, teste = 1;
    bool ok;
    for (i = 0; i < LIN; i++) {
        for (j = 0; j < COL; j++) {
            scanf("%d", &tab[i][j]);
        }
    }
    ok = true;
    for (i = 0; i < LIN && ok; i++) {
        ok = verifica_linha(i, tab);
    }
    for (i = 0; i < LIN && ok; i++) {
        ok = verifica_coluna(i, tab);
    }
    for (i = 0; i < LIN && ok; i++) {
        ok = verifica_regiao(i, tab);
    }
    printf("%s\n", ok ? "SIM" : "NAO");
    return 0;
}

bool verifica_linha(int lin, int tab[][COL])
{
    static bool linha[LIN];
    int i;
    for (i = 0; i < LIN; linha[i++] = false);
    for (i = 0; i < LIN; i++) {
        linha[tab[lin][i]-1] = true;
    }
    return !tem_nulo(linha);
}

bool verifica_coluna(int col, int tab[][COL])
{
    static bool coluna[COL];
    int i;
    for (i = 0; i < COL; coluna[i++] = false);
    for (i = 0; i < COL; i++) {
        coluna[tab[i][col]-1] = true;
    }
    return !tem_nulo(coluna);
}

bool verifica_regiao(int reg, int tab[][COL])
{
    static bool regiao[LIN];
    int i, j, index_i, index_j;
    index_i = reg / 3;
    index_j = reg % 3;
    for (i = 0; i < LIN; regiao[i++] = false);
    for (i = 0; i < 3; i++) {
        for (j = 0; j < 3; j++) {
            regiao[tab[index_i * 3 + i][index_j * 3 + j]-1] = true;
        }
    }
    return !tem_nulo(regiao);
}

bool tem_nulo(bool vet[])
{
    int i;
    for (i = 0; i < LIN && vet[i]; i++);
    return i < LIN;
}

