module Main where

import System.Environment
import System.IO
import Control.Monad

brk :: [Int] -> String -> [String]
brk (x:xs) str = let k = take x str in [k] ++ (brk xs (drop x str))
brk [] _ = []

intChar :: Int -> Char
intChar 1 = '!'
intChar 2 = '@'
intChar 3 = '#'
intChar 4 = '$'
intChar 5 = '%'
intChar 6 = '^'

charLetter :: Char -> Char
charLetter '!' ='A'
charLetter '@' ='B'
charLetter '#' ='C'
charLetter '$' ='D'
charLetter '%' ='E'
charLetter '^' ='F'

filterW :: [Int] -> String -> Char
filterW xs str = let ts = map (\x-> filter (==(intChar x)) str) xs in head $ head $ filter (\t -> length t == (maximum $ map length ts)) ts  

main :: IO ()
main = do
    firstLine <- fmap words getLine
    states <- (return $ read $ firstLine !! 0) :: IO Int
    parties <- (return $ read $ firstLine !! 1) :: IO Int
    electors <- fmap words getLine 
    electorsInt <- (return $ map read electors) :: IO [Int]
    evs <- fmap words getLine
    evsInt <- (return $ map read evs) :: IO [Int]
    votes <- getLine
    votesPerState <- return $ brk electorsInt votes
    winners <- return $ map (\x-> filterW [1..parties] x) votesPerState 
    msgs <- return $ map (\x-> [charLetter $ intChar x] ++ ": " ++ show (sum $ map snd $ filter (\y -> fst y == intChar x) (zip winners evsInt))) [1..parties]
    mapM_ putStrLn msgs
    
    
    