module Main where

import Data.List
import Control.Applicative

data Zipper = Zipper [Int] Int [Int] deriving Show

readAll :: Int -> IO [String]
readAll k 
    | k <= 0 = return []
    | otherwise = do
        linez <- getLine
        fmap (linez :) $ readAll (k-1) 

esq :: Zipper -> Zipper
esq (Zipper [] c rs) = Zipper [] c rs 
esq (Zipper ls c rs) = Zipper (reverse . tail . reverse $ ls) (head . reverse $ ls) (c:rs)


dir :: Zipper -> Zipper
dir (Zipper ls c []) = Zipper ls c [] 
dir (Zipper ls c (r:rs)) = Zipper (ls++[c]) r rs

toZipper :: Int -> [Int] -> Zipper
toZipper ix ls = Zipper (take ix ls) (ls !! ix) (drop (ix+1) ls)

directions :: String -> Zipper -> Zipper
directions "esq" z = esq z
directions "dir" z = dir z
directions _ z = z

main :: IO ()
main = do
    firstLine <- fmap words getLine
    tamanho <- (return $ read $ firstLine !! 0) :: IO Int
    lista <- fmap (map read . words) getLine :: IO [Int]
    thirdLine <- fmap words getLine
    foco <- (return $ read $ thirdLine !! 0) :: IO Int
    percurso <- (return $ read $ thirdLine !! 1) :: IO Int
    direcoes <- readAll percurso
    putStrLn $ filter (\x -> and [' ' /= x,')' /= x,'(' /= x] ) $ drop 7 $ show $ foldl (\z x-> directions x z) (toZipper foco lista) direcoes
    
    
    